
#COMPILE EXE
#REGISTER NONE
#DIM ALL          '  This is helpful to prevent errors in coding


#INCLUDE "win32api.inc"   ' Must come first before other include files !
' *************************************************************

DECLARE SUB EZLIB_DefColors()
DECLARE SUB EZLIB_DeleteBrushes()
DECLARE FUNCTION EZLIB_QBColor(N&) AS LONG

%FORM1_LABEL3             = 100
%FORM1_LABEL2             = 105
%FORM1_LABEL1             = 110
%FORM1_CUSTOM1            = 115
%FORM1_BUTTON1            = 120
%FORM1_BUTTON2            = 125
%FORM1_BUTTON3            = 130

' --------------------------------------------------
DECLARE SUB ShowDialog_Form1(BYVAL hParent&)
DECLARE CALLBACK FUNCTION Form1_DLGPROC
' --------------------------------------------------

DECLARE CALLBACK FUNCTION CBF_FORM1_CUSTOM1()
DECLARE CALLBACK FUNCTION CBF_FORM1_BUTTON1()
DECLARE CALLBACK FUNCTION CBF_FORM1_BUTTON2()
DECLARE CALLBACK FUNCTION CBF_FORM1_BUTTON3()

GLOBAL App_Brush&()
GLOBAL App_Color&()
GLOBAL App_Font&()
GLOBAL hForm1&    ' Dialog handle

%MY_CUSTOM_MESSAGE   =   %WM_USER + 100

FUNCTION PBMAIN
    LOCAL Count&
    LOCAL hDLL AS LONG

    EZLIB_DefColors
    hDLL=LoadLibrary("cusctrl1.dll")
    ShowDialog_Form1 0
    DO
        DIALOG DOEVENTS TO Count&
    LOOP UNTIL Count&=0

    FreeLibrary hDLL
    EZLIB_DeleteBrushes
END FUNCTION

SUB ShowDialog_Form1(BYVAL hParent&)
    LOCAL Style&, ExStyle&
    Style& = %WS_POPUP OR %DS_MODALFRAME OR %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_SYSMENU OR %DS_CENTER OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
    ExStyle& = 0
    DIALOG NEW hParent&, "Custom Control Sample Project", 0, 0,  267,  177, Style&, ExStyle& TO hForm1&
    CONTROL ADD LABEL, hForm1&,  %FORM1_LABEL3,  "", 67, 57, 21, 10, _
        %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER OR %WS_BORDER
    CONTROL ADD LABEL, hForm1&,  %FORM1_LABEL2,  "", 67, 37, 21, 10, _
        %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER OR %WS_BORDER
    CONTROL ADD LABEL, hForm1&,  %FORM1_LABEL1,  "", 67, 17, 21, 10, _
        %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER OR %WS_BORDER
    CONTROL ADD "MY_CUSTOM_CTRL1", hForm1&,  %FORM1_CUSTOM1, "", 99, 12, 157, 153, _
                %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_THICKFRAME , %WS_EX_CLIENTEDGE
    CONTROL ADD "Button", hForm1&,  %FORM1_BUTTON1,  "Red BG", 8, 15, 53, 15, _
        %WS_CHILD OR %WS_VISIBLE OR %BS_PUSHBUTTON OR %WS_TABSTOP CALL CBF_FORM1_BUTTON1
    CONTROL ADD "Button", hForm1&,  %FORM1_BUTTON2,  "Green BG", 8, 34, 53, 15, _
        %WS_CHILD OR %WS_VISIBLE OR %BS_PUSHBUTTON OR %WS_TABSTOP CALL CBF_FORM1_BUTTON2
    CONTROL ADD "Button", hForm1&,  %FORM1_BUTTON3,  "Blue BG", 8, 54, 53, 15, _
        %WS_CHILD OR %WS_VISIBLE OR %BS_PUSHBUTTON OR %WS_TABSTOP CALL CBF_FORM1_BUTTON3
    DIALOG SHOW MODELESS hForm1& , CALL Form1_DLGPROC
END SUB

CALLBACK FUNCTION Form1_DLGPROC
    SELECT CASE CBMSG
        CASE %WM_CTLCOLORSTATIC
            SELECT CASE GetDlgCtrlID(CBLPARAM)
                CASE  %FORM1_LABEL3
                    SetTextColor CBWPARAM, App_Color&( 0)
                    SetBkColor   CBWPARAM, App_Color&( 9)
                    FUNCTION=App_Brush&( 9)
                CASE  %FORM1_LABEL2
                    SetTextColor CBWPARAM, App_Color&( 0)
                    SetBkColor   CBWPARAM, App_Color&( 10)
                    FUNCTION=App_Brush&( 10)
                CASE  %FORM1_LABEL1
                    SetTextColor CBWPARAM, App_Color&( 0)
                    SetBkColor   CBWPARAM, App_Color&( 12)
                    FUNCTION=App_Brush&( 12)
                CASE ELSE
                    FUNCTION=0
            END SELECT
        CASE ELSE
    END SELECT
END FUNCTION

' *************************************************************
'              EZGUI Freeware Dialog Designer Library
'
'                   see web site at EZGUI.COM
'
' Copyright (C) 2000, Christopher R. Boss , All Rights Reserved !
'
' This code was Generated by the EZGUI Freeware Dialog Designer
' and may be used ROYALTY FREE, as long as this Copyright notice
' is kept with the source code.
' The Author also gives you the right to post this code on a
' web site and to distribute it to others.
' *************************************************************

SUB EZLIB_DefColors()
    LOCAL T&
    REDIM App_Brush&(0 TO 31)
    REDIM App_Color&(0 TO 31)
    FOR T&=0 TO 31
        App_Brush&(T&)=CreateSolidBrush(EZLIB_QBColor(T&))
        App_Color&(T&)=EZLIB_QBColor(T&)
    NEXT T&
END SUB

' -------------------------------------------------------------

SUB EZLIB_DeleteBrushes()
    LOCAL T&
    FOR T&=0 TO 31
        DeleteObject App_Brush&(T&)
    NEXT T&
END SUB

' -------------------------------------------------------------

FUNCTION EZLIB_QBColor(N&) AS LONG
    LOCAL RV&
    SELECT CASE N&
        CASE 0
        RV&=RGB(0,0,0)       ' Black
    CASE 1
        RV&=RGB(0,0,128)     ' Blue
    CASE 2
        RV&=RGB(0,128,0)     ' Green
    CASE 3
        RV&=RGB(0,128,128)   ' Cyan
    CASE 4
        RV&=RGB(196,0,0)     ' Red
    CASE 5
        RV&=RGB(128,0,128)   ' Magenta (Purple)
    CASE 6
        RV&=RGB(128,64,0)    ' Brown
    CASE 7
        RV&=RGB(196,196,196) ' White
    CASE 8
        RV&=RGB(128,128,128) ' Gray
    CASE 9
        RV&=RGB(0,0, 255)    ' Lt. Blue
    CASE 10
        RV&=RGB(0,255,0)     ' Lt. Green
    CASE 11
        RV&=RGB(0,255,255)   ' Lt. Cyan
    CASE 12
        RV&=RGB(255,0,0)     ' Lt. Red
    CASE 13
        RV&=RGB(255,0,255)   ' Lt. magenta (Purple)
    CASE 14
        RV&=RGB(255,255,0)   ' Yellow
    CASE 15
        RV&=RGB(255,255,255) ' Bright White
    CASE 16   ' - Extended QB colors Pastel version -
        RV&=RGB(164,164,164)
    CASE 17
        RV&=RGB(128,160,255)
    CASE 18
        RV&=RGB(160,255,160)
    CASE 19
        RV&=RGB(160,255,255)
    CASE 20
        RV&=RGB(255,160,160)
    CASE 21
        RV&=RGB(255,160,255)
    CASE 22
        RV&=RGB(255,255,160)
    CASE 23
        RV&=RGB(212,212,212)
    CASE 24
        RV&=RGB(180,180,180)
    CASE 25
        RV&=RGB(188,220,255)
    CASE 26
        RV&= RGB(220,255,220)
    CASE 27
        RV&=RGB(220,255,255)
    CASE 28
        RV&=RGB(255,220,220)
    CASE 29
        RV&=RGB(255,220,255)
    CASE 30
        RV&=RGB(255,255,220)
    CASE 31
        RV&=RGB(228,228,228)
    CASE ELSE
        RV&=RGB(0,0,0)
    END SELECT
    FUNCTION=RV&
END FUNCTION

' *************************************************************
'             End of EZGUI Dynamic Dialogs Library
' *************************************************************


' ------------------------------------------------
CALLBACK FUNCTION CBF_FORM1_CUSTOM1
END FUNCTION
' ------------------------------------------------

' ------------------------------------------------
CALLBACK FUNCTION CBF_FORM1_BUTTON1
    IF CBCTLMSG=%BN_CLICKED THEN
        CONTROL SEND hForm1&, %FORM1_CUSTOM1, %MY_CUSTOM_MESSAGE, RGB(255,0,0), 0
    END IF
END FUNCTION
' ------------------------------------------------

' ------------------------------------------------
CALLBACK FUNCTION CBF_FORM1_BUTTON2
    IF CBCTLMSG=%BN_CLICKED THEN
        CONTROL SEND hForm1&, %FORM1_CUSTOM1, %MY_CUSTOM_MESSAGE, RGB(0,255,0), 0
    END IF
END FUNCTION
' ------------------------------------------------

' ------------------------------------------------
CALLBACK FUNCTION CBF_FORM1_BUTTON3
    IF CBCTLMSG=%BN_CLICKED THEN
        CONTROL SEND hForm1&, %FORM1_CUSTOM1, %MY_CUSTOM_MESSAGE, RGB(0,0,255), 0
    END IF
END FUNCTION
' ------------------------------------------------
